package agents;

import enums.Phases;
import enums.Types;
import estructures.MapPosition;

import java.util.Random;

import managers.MapManager;
import behaviours.*;
import jade.core.Agent;
import jade.core.behaviours.*;

public class PlantAgent extends LivingAgent {

	public PlantAgent(){
		type=Types.PLANT;
		phase=Phases.YOUNG;
		
		watchingDistance = 6;
		borningDistance = 3;
		reproductionEnergy = 100;
		energy = 75 + (int) (150 * new Random().nextFloat());
		eatingEnergy = 40;
		maxEnergy = 300;
	}
	
	protected void setup() {

		super.setup();
		
		
		Behaviour behaviour;
		SequentialBehaviour seq = new SequentialBehaviour(this);
		ParallelBehaviour par = new ParallelBehaviour(this,
				ParallelBehaviour.WHEN_ANY);	

		par = new ParallelBehaviour(this, ParallelBehaviour.WHEN_ANY);
		par.addSubBehaviour(new PlantGetOldBehaviour(this));
		par.addSubBehaviour(new PlantReproductingBehaviour(this));

		seq = new SequentialBehaviour(this);
		seq.addSubBehaviour(new PlantGetMatureBehaviour(this));
		seq.addSubBehaviour(par);

		par = new ParallelBehaviour(this, ParallelBehaviour.WHEN_ANY);
		par.addSubBehaviour(seq);
		par.addSubBehaviour(new EnergyLossBehaviour(this));
		par.addSubBehaviour(new PlantGetFoodBehaviour(this));
		par.addSubBehaviour(new BeEatenBehaviour(this));
		
		
		seq = new SequentialBehaviour(this);
		seq.addSubBehaviour(par);
		seq.addSubBehaviour(new DeadBehaviour(this));

		this.addBehaviour(seq);

	}
}
