package gui;

import jade.core.Agent;

import javax.swing.JFrame;
import javax.swing.JPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.HashMap;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;
import javax.swing.JButton;

import enums.Types;
import estructures.MapPosition;
import managers.MapManager;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JSpinner;

import java.awt.Component;

import javax.swing.SpinnerNumberModel;

public class MapGUI extends JFrame {

	private Color mapBackGround = new Color(255, 204, 153);

	private int pointSize=13;
	private int mapSize=390;
	
	private JSpinner textCarnivores;
	private JSpinner textHerbivores;
	private JSpinner textPlants;

	private JPanel panel;
	
	private JButton btnSimulate;
	private JButton btnReset;

	public MapGUI() {

		
		
		this.setBounds(200, 200, 500, 650);
		this.setTitle("Map");

		panel = new JPanel();
		panel.setLayout(null);
		panel.setBounds(43, 27, mapSize, mapSize);
		panel.setBackground(mapBackGround);				
			
		
		getContentPane().setLayout(null);
		getContentPane().add(panel);

		JLabel lblPredators = new JLabel("Carnivores:");
		lblPredators.setHorizontalAlignment(SwingConstants.RIGHT);
		lblPredators.setBounds(43, 450, 65, 14);
		getContentPane().add(lblPredators);

		JLabel lblHerbivores = new JLabel("Herbivores:");
		lblHerbivores.setHorizontalAlignment(SwingConstants.RIGHT);
		lblHerbivores.setBounds(43, 475, 65, 14);
		getContentPane().add(lblHerbivores);

		JLabel lblPlants = new JLabel("Plants:");
		lblPlants.setHorizontalAlignment(SwingConstants.RIGHT);
		lblPlants.setBounds(43, 500, 65, 14);
		getContentPane().add(lblPlants);

		textCarnivores = new JSpinner();
		textCarnivores.setModel(new SpinnerNumberModel(0, 0, 100, 1));
		textCarnivores.setAlignmentX(SwingConstants.CENTER);
		textCarnivores.setBounds(113, 450, 60, 20);
		textCarnivores.setValue(10);
		getContentPane().add(textCarnivores);

		textHerbivores = new JSpinner();
		textHerbivores.setModel(new SpinnerNumberModel(0, 0, 100, 1));
		textHerbivores.setAlignmentX(SwingConstants.CENTER);
		textHerbivores.setBounds(113, 475, 60, 20);
		textHerbivores.setValue(40);
		getContentPane().add(textHerbivores);

		textPlants = new JSpinner();
		textPlants.setModel(new SpinnerNumberModel(0, 0, 100, 1));
		textPlants.setAlignmentX(SwingConstants.CENTER);
		textPlants.setBounds(113, 500, 60, 20);
		textPlants.setValue(80);
		getContentPane().add(textPlants);
		
			
		btnSimulate = new JButton("SIMULATE");
		btnSimulate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				btnSimulate.setEnabled(false);					
				textCarnivores.setEnabled(false);
				textHerbivores.setEnabled(false);
				textPlants.setEnabled(false);
				
				MapManager.startSimulation();
				
				int carnivores = (int)textCarnivores.getValue();
				int herbivores = (int)textHerbivores.getValue();
				int plants = (int)textPlants.getValue();
				
				for (int i = 0; i < carnivores; i++){
					MapManager.createLivingAgent(Types.CARNIVORE, null);
				}
				for (int i = 0; i < herbivores; i++){
					MapManager.createLivingAgent(Types.HERBIVORE, null);
				}
				for (int i = 0; i < plants; i++){
					MapManager.createLivingAgent(Types.PLANT, null);
				}
				
				
				//btnSimulate.setVisible(false);	
				//btnReset.setVisible(true);	
				//btnReset.setEnabled(true);	
			}
		});
		btnSimulate.setBounds(43, 531, 175, 70);
		getContentPane().add(btnSimulate);
		
		
		btnReset = new JButton("RESET");
		btnReset.setVisible(false);	
		btnReset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				btnReset.setEnabled(false);	
				MapManager.resetSimulation();		
				textCarnivores.setEnabled(true);
				textHerbivores.setEnabled(true);
				textPlants.setEnabled(true);				
				btnReset.setVisible(false);	
				btnSimulate.setVisible(true);	
				btnSimulate.setEnabled(true);	
			}
		});
		btnReset.setBounds(43, 531, 175, 70);
		getContentPane().add(btnReset);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBackground(Color.GREEN);
		panel_1.setBounds(433, 460, 10, 10);
		getContentPane().add(panel_1);
		
		JPanel panel_2 = new JPanel();
		panel_2.setBackground(new Color(0, 153, 0));
		panel_2.setBounds(433, 485, 10, 10);
		getContentPane().add(panel_2);
		
		JPanel panel_3 = new JPanel();
		panel_3.setBackground(new Color(255, 255, 0));
		panel_3.setBounds(433, 510, 10, 10);
		getContentPane().add(panel_3);
		
		JPanel panel_4 = new JPanel();
		panel_4.setBackground(new Color(128, 128, 0));
		panel_4.setBounds(433, 535, 10, 10);
		getContentPane().add(panel_4);
		
		JPanel panel_5 = new JPanel();
		panel_5.setBackground(new Color(255, 0, 0));
		panel_5.setBounds(433, 560, 10, 10);
		getContentPane().add(panel_5);
		
		JPanel panel_6 = new JPanel();
		panel_6.setBackground(new Color(128, 0, 0));
		panel_6.setBounds(433, 585, 10, 10);
		getContentPane().add(panel_6);
		
		JPanel panel_7 = new JPanel();
		panel_7.setBackground(new Color(0, 0, 0));
		panel_7.setBounds(433, 435, 10, 10);
		getContentPane().add(panel_7);
		
		JLabel lblDead = new JLabel("Dead");
		lblDead.setHorizontalAlignment(SwingConstants.RIGHT);
		lblDead.setBounds(292, 435, 135, 14);
		getContentPane().add(lblDead);
		
		JLabel lblYoungPlant = new JLabel("Young plant");
		lblYoungPlant.setHorizontalAlignment(SwingConstants.RIGHT);
		lblYoungPlant.setBounds(292, 460, 135, 14);
		getContentPane().add(lblYoungPlant);
		
		JLabel lblMaturePlant = new JLabel("Mature plant");
		lblMaturePlant.setHorizontalAlignment(SwingConstants.RIGHT);
		lblMaturePlant.setBounds(292, 485, 135, 14);
		getContentPane().add(lblMaturePlant);
		
		JLabel lblMatureHerbivore = new JLabel("Mature herbivore");
		lblMatureHerbivore.setHorizontalAlignment(SwingConstants.RIGHT);
		lblMatureHerbivore.setBounds(292, 535, 135, 14);
		getContentPane().add(lblMatureHerbivore);
		
		JLabel lblYoungHerbivore = new JLabel("Young herbivore");
		lblYoungHerbivore.setHorizontalAlignment(SwingConstants.RIGHT);
		lblYoungHerbivore.setBounds(292, 510, 135, 14);
		getContentPane().add(lblYoungHerbivore);
		
		JLabel lblMatureCarnivore = new JLabel("Mature carnivore");
		lblMatureCarnivore.setHorizontalAlignment(SwingConstants.RIGHT);
		lblMatureCarnivore.setBounds(292, 585, 135, 14);
		getContentPane().add(lblMatureCarnivore);
		
		JLabel lblYoungCarnivore = new JLabel("Young carnivore");
		lblYoungCarnivore.setHorizontalAlignment(SwingConstants.RIGHT);
		lblYoungCarnivore.setBounds(292, 560, 135, 14);
		getContentPane().add(lblYoungCarnivore);

	}
	
	
	public JPanel drawPoint (int x, int y, Color color){
		JPanel p = null;
		if (x >= 0 && x < panel.getBounds().width && y >= 0
			&& y < panel.getBounds().height) {
			
			p = new JPanel();
			p.setLayout(null);			
			p.setBounds(x*pointSize, y*pointSize, pointSize, pointSize);
			p.setBackground(color);	
			p.setBorder(new LineBorder(color.darker()));
			
			panel.add(p);	
			panel.repaint();
		}
		return p;
	}
	
	public void removePoint(JPanel p){	
		//System.out.println("Removed panel in ("+p.getBounds().x/pointSize+", "+p.getBounds().y/pointSize+")");
		try{
			panel.remove(p);	
			panel.repaint();			
		}catch(Exception e){}
	}
	
	public void movePoint(JPanel p, MapPosition position){
		p.setBounds(position.getX()*pointSize, position.getY()*pointSize, pointSize, pointSize);
	}
	
	
	public void setLivings (int carnivores, int herbivores, int plants){
		setCarnivores(carnivores);
		setHerbivores(herbivores);
		setPlants(plants);
	}
	
	public void setCarnivores(int i){
		textCarnivores.setValue(i);
	}
	
	public void setHerbivores(int i){
		textHerbivores.setValue(i);
	}
	
	public void setPlants(int i){
		textPlants.setValue(i);
	}
}
