package behaviours;

import java.util.Random;

import managers.MapManager;
import enums.Types;
import agents.LivingAgent;
import jade.core.behaviours.CyclicBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

public class AnimalReproductionBehaviour extends CyclicBehaviour {

	public AnimalReproductionBehaviour(LivingAgent a) {
		super(a);
	}

	@Override
	public void action() {
		block();
		ACLMessage msg = myAgent.receive(MessageTemplate.and(
				MessageTemplate.MatchContent("Reproduce"),
				MessageTemplate.or(
						MessageTemplate.or(
								MessageTemplate.MatchPerformative(ACLMessage.ACCEPT_PROPOSAL),
								MessageTemplate.MatchPerformative(ACLMessage.REJECT_PROPOSAL)),
						MessageTemplate.MatchPerformative(ACLMessage.PROPOSE))));

		if (msg != null) {

			LivingAgent myLivingAgent = (LivingAgent) myAgent;

			ACLMessage reply = msg.createReply();
			reply.setContent(msg.getContent());

			switch (msg.getPerformative()) {
			case ACLMessage.PROPOSE:

				if (myLivingAgent.enoughEnergyToReproduce()) {
					reply.setPerformative(ACLMessage.ACCEPT_PROPOSAL);
					System.out.println(myAgent.getLocalName()+ ": Pareces un buen partido, adelante.");					
					
					myLivingAgent.removeReproductionEnergy();
					

				} else {
					reply.setPerformative(ACLMessage.REJECT_PROPOSAL);
					System.out.println(myAgent.getLocalName()
							+ ": Estoy muy hambrieto/a para eso!");
				}

				myLivingAgent.send(reply);
				
				break;

				
				
				

			case ACLMessage.ACCEPT_PROPOSAL:

				if (myLivingAgent.enoughEnergyToReproduce()
						&& MapManager.createLivingAgent(
								myLivingAgent.getType(), myLivingAgent)) {
					myLivingAgent.removeReproductionEnergy();					
					System.out.println(myAgent.getLocalName() + ": un nuevo cachorro ha nacido");
				}

				break;
				
				
				
				

			case ACLMessage.REJECT_PROPOSAL:

				System.out.println(myAgent.getLocalName()
						+ ": Tu te lo pierdes. Tal vez en otro momento");

				break;

			}

		}

	}

}
