package behaviours;

import managers.MapManager;
import enums.Phases;
import agents.LivingAgent;
import jade.core.Agent;
import jade.core.behaviours.OneShotBehaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

public class BeEatenBehaviour extends SimpleBehaviour {

	private boolean eaten = false;

	public BeEatenBehaviour(LivingAgent a) {
		super(a);
	}

	@Override
	public void action() {
		
			block();
			
			
			 ACLMessage msg = myAgent.receive(MessageTemplate.and(
					 MessageTemplate.MatchPerformative(ACLMessage.INFORM),
					 MessageTemplate.MatchContent("Eaten")));
			 

			if (msg != null) {
				
					((LivingAgent) myAgent).setPhase(Phases.DEAD);
					MapManager.updateColor((LivingAgent) myAgent);
					System.out.println(myAgent.getLocalName()
							+ ": Me han comido!!");
					eaten = true;
				
			}
		
	}

	@Override
	public boolean done() {
		return eaten;
	}

}
