package behaviours;

import managers.MapManager;
import enums.Phases;
import agents.LivingAgent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.SimpleBehaviour;

public class EnergyLossBehaviour extends SimpleBehaviour{

	
	private boolean dead = false;
	
	public EnergyLossBehaviour(LivingAgent a){
		super(a);
	}
	
	public void action() {
		LivingAgent myLivingAgent= ((LivingAgent)myAgent);
		myLivingAgent.removeEnergy(1);
		if(myLivingAgent.getEnergy()<0){	
			
			myLivingAgent.setPhase(Phases.DEAD);
			MapManager.updateColor((LivingAgent)myAgent);
			dead=true;
		}
		
		//System.out.println(myAgent.getLocalName()+": Perdida de energia. Energia a "+((LivingAgent)myAgent).getEnergy());
		
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public int onEnd(){
		System.out.println(myAgent.getLocalName()+": He muerto de hambre!!");
		return super.onEnd();		
	}

	@Override
	public boolean done() {
		return dead;
	}
}
