package behaviours;

import enums.Types;
import managers.IdManager;
import managers.MapManager;
import agents.LivingAgent;
import jade.core.Agent;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.wrapper.AgentController;
import jade.wrapper.ContainerController;
import jade.wrapper.StaleProxyException;

public class PlantReproductingBehaviour extends CyclicBehaviour {

	public PlantReproductingBehaviour(LivingAgent a) {
		super(a);
	}

	@Override
	public void action() {
		block();
		
	
		
		ACLMessage msg = myAgent.receive(MessageTemplate.and(
				MessageTemplate.MatchPerformative(ACLMessage.INFORM),
				MessageTemplate.MatchContent("Spring")));
		
		if (msg != null) {
			
			int newPlants = 0;
			while (((LivingAgent) myAgent).enoughEnergyToReproduce()
					&& MapManager.createLivingAgent(Types.PLANT,
							(LivingAgent) myAgent)) {
				((LivingAgent) myAgent).removeReproductionEnergy();
				newPlants++;
			}
			if (newPlants > 0) {
				System.out.println(myAgent.getLocalName() + ": "
						+ newPlants + " nueva(s) plantas(s) ha(n) surgido");
			}				
			
		}
	}
}
